## deepin-service-plugins 1.0.1.1

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
cmake_minimum_required(VERSION 3.13)

set (VERSION "1.0.0" CACHE STRING "define project version")

project(deepin-service)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()

include(GNUInstallDirs)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
# 设置二进制输出目录 方便调试
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")

add_subdirectory("src")

=== src/plugin-qt/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(Qt5 COMPONENTS Core DBus REQUIRED)

find_package(PkgConfig REQUIRED)

# add_subdirectory("xxx")

=== src/plugin-sdbus/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

option(ENABLE_PLUGIN_OOM "Build plugin-oom" ON)
option(ENABLE_PLUGIN_IPWATCHD "Build plugin-ipwatchd" ON)

if (ENABLE_PLUGIN_OOM)
    add_subdirectory("plugin-oom")
endif()

if (ENABLE_PLUGIN_IPWATCHD)
    add_subdirectory("plugin-ipwatchd")
endif()

=== src/demo/libqdbusservice-demo/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
cmake_minimum_required(VERSION 3.13)

set(BIN_NAME "qdbus-service-demo")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

project(${BIN_NAME})

include(GNUInstallDirs)
find_package(Qt5 COMPONENTS Core DBus REQUIRED)
if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug") # delete this judgement in your project
  find_package(deepin-qdbus-service REQUIRED) # just need this in your project
endif()

qt5_add_dbus_adaptor(ADAPTER_SOURCES
                     org.deepin.service.sdk.demo.xml
                     service.h
                     Service)

file(GLOB_RECURSE SRCS
  "main.cpp"
  "service.cpp"
)

add_executable(${BIN_NAME}
    ${SRCS}
    ${ADAPTER_SOURCES}
)
if (CMAKE_BUILD_TYPE STREQUAL "Debug") # delete this judgement in your project
    set(Service_INCLUDE_DIR ${SRC_BASE_DIR}/libqdbusservice)
    set(Service_LIBRARIES deepin-qdbus-service)
    target_link_directories(${BIN_NAME} PRIVATE
        ${CMAKE_BINARY_DIR}/lib
    )
else()
    # just need this in your project
    set(Service_INCLUDE_DIR ${deepin-qdbus-service_INCLUDE_DIR})
    set(Service_LIBRARIES ${deepin-qdbus-service_LIBRARIES})
    add_definitions(-DSERVICE_CONFIG_DIR="${CMAKE_INSTALL_PREFIX}/share/deepin-service-manager/")
endif()

target_include_directories(${BIN_NAME} PUBLIC
  Qt5::Core
  Qt5::DBus
  ${Service_INCLUDE_DIR}
)

target_link_libraries(${BIN_NAME} PRIVATE
  Qt5::Core
  Qt5::DBus
  ${Service_LIBRARIES}
)

if (CMAKE_BUILD_TYPE STREQUAL "Debug") # delete this judgement in your project
    EXECUTE_PROCESS(COMMAND mkdir -p ${CMAKE_BINARY_DIR}/share/other/)
    EXECUTE_PROCESS(COMMAND cp -f ${CMAKE_CURRENT_SOURCE_DIR}/sdk-demo.json ${CMAKE_BINARY_DIR}/share/other/)
else()
    # just need this in your project
    install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
    install(FILES sdk-demo.json DESTINATION share/deepin-service-manager/other/)
endif()

install(FILES org.deepin.service.sdk.demo.service DESTINATION share/dbus-1/system-services/)
install(FILES org.deepin.service.sdk.demo.conf
    DESTINATION share/dbus-1/system.d/
)

=== src/demo/plugin-sdbus/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
cmake_minimum_required(VERSION 3.7)

# TODO:C compile

add_subdirectory("demo1")

=== src/plugin-sdbus/plugin-ipwatchd/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
cmake_minimum_required(VERSION 3.13)

set(Plugin_NAME "plugin-ipwatchd")

project(${Plugin_NAME})

find_package(PkgConfig REQUIRED)
find_package(Qt5 COMPONENTS LinguistTools REQUIRED)
pkg_check_modules(Systemd REQUIRED IMPORTED_TARGET libsystemd)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(PCAP REQUIRED libpcap)
find_library(NET_LIB net)

include_directories(${GLIB_INCLUDE_DIRS})
link_directories(${GLIB_LIBRARY_DIRS})
add_definitions(${GLIB_CFLAGS_OTHER})
include_directories(${PCAP_INCLUDE_DIRS})
link_directories(${PCAP_LIBRARY_DIRS})

# Sources files
file(GLOB_RECURSE SRCS "*.c" "*.h")

add_library(${Plugin_NAME} MODULE
    ${SRCS}
)

target_include_directories(${Plugin_NAME} PUBLIC
    PkgConfig::Systemd
)

target_link_libraries(${Plugin_NAME}
    PkgConfig::Systemd
    pthread
    ${PCAP_LIBRARIES}
    ${NET_LIB}
)

if (CMAKE_BUILD_TYPE STREQUAL "Debug") # delete this judgement in your project
    EXECUTE_PROCESS(COMMAND mkdir -p ${CMAKE_BINARY_DIR}/share/system/)
    EXECUTE_PROCESS(COMMAND cp -f ${CMAKE_CURRENT_SOURCE_DIR}/plugin-ipwatchd.json ${CMAKE_BINARY_DIR}/share/system/)
    target_compile_definitions(${Plugin_NAME} PRIVATE _DEBUG)
else()
    # just need this in your project
    install(TARGETS ${Plugin_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/deepin-service-manager/)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/plugin-ipwatchd.json DESTINATION share/deepin-service-manager/system/)
endif()

install(FILES org.deepin.ipwatchd.conf
    DESTINATION share/dbus-1/system.d/
)

=== src/plugin-sdbus/plugin-oom/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
cmake_minimum_required(VERSION 3.13)

set(Plugin_NAME "plugin-oom")

project(${Plugin_NAME})

find_package(Qt5 COMPONENTS Core DBus REQUIRED)

find_package(PkgConfig REQUIRED)
find_package(Qt5 COMPONENTS LinguistTools REQUIRED)
pkg_check_modules(Systemd REQUIRED IMPORTED_TARGET libsystemd)

# Sources files
file(GLOB_RECURSE SRCS "*.c" "*.h")

file(GLOB TS_FILES "translations/*.ts")
qt5_add_translation(QM_FILES ${TS_FILES})
add_custom_target(oomtranslations ALL DEPENDS ${QM_FILES})

add_library(${Plugin_NAME} MODULE
    ${SRCS}
)

target_include_directories(${Plugin_NAME} PUBLIC
    PkgConfig::Systemd
)

target_link_libraries(${Plugin_NAME}
    PkgConfig::Systemd
    pthread
)

if (CMAKE_BUILD_TYPE STREQUAL "Debug") # delete this judgement in your project
    EXECUTE_PROCESS(COMMAND mkdir -p ${CMAKE_BINARY_DIR}/share/system/)
    EXECUTE_PROCESS(COMMAND cp -f ${CMAKE_CURRENT_SOURCE_DIR}/plugin-oom.json ${CMAKE_BINARY_DIR}/share/system/)
    target_compile_definitions(${Plugin_NAME} PRIVATE _DEBUG)
else()
    # just need this in your project
    install(TARGETS ${Plugin_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/deepin-service-manager/)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/plugin-oom.json DESTINATION share/deepin-service-manager/system/)
endif()

install(FILES org.deepin.oom1.conf
    DESTINATION share/dbus-1/system.d/
)

install(FILES org.deepin.oom.json
    DESTINATION share/dsg/configs/org.deepin.oom/
)

install(FILES earlyoom.service.json
    DESTINATION lib/deepin-daemon/service-trigger/)

# 安装.qm文件
install(FILES ${QM_FILES} DESTINATION share/deepin-service-plugins/oom/translations)
# 安装getfromqm脚本
install(FILES getfromqm DESTINATION bin)

=== src/demo/plugin-qt/demo1/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later
cmake_minimum_required(VERSION 3.13)

set(BIN_NAME "plugin-qt-demo1")

project(${BIN_NAME})

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

include(GNUInstallDirs)
file(GLOB_RECURSE SRCS "*.h" "*.cpp")

find_package(Qt5 COMPONENTS Core DBus REQUIRED)

add_library(${BIN_NAME} MODULE
    ${SRCS}
)

target_include_directories(${BIN_NAME} PUBLIC
  Qt5::Core
  Qt5::DBus
)

target_link_libraries(${BIN_NAME} PRIVATE
  Qt5::Core
  Qt5::DBus
)

if (CMAKE_BUILD_TYPE STREQUAL "Debug") # delete this judgement in your project
    EXECUTE_PROCESS(COMMAND mkdir -p ${CMAKE_BINARY_DIR}/share/user/)
    EXECUTE_PROCESS(COMMAND cp -f ${CMAKE_CURRENT_SOURCE_DIR}/plugin-qt-demo1.json ${CMAKE_BINARY_DIR}/share/user/)
else()
    # just need this in your project
    install(TARGETS ${BIN_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/deepin-service-manager/)
    install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/plugin-qt-demo1.json DESTINATION share/deepin-service-manager/system/)
endif()

install(FILES org.deepin.service.demo1.conf
    DESTINATION share/dbus-1/system.d/
)

=== debian/changelog ===
deepin-service-plugins (1.0.1.1-1) unstable; urgency=medium

  * update

 -- Deepin Sysdev <sysdev@deepin.com>  Thu, 24 Oct 2024 17:34:01 +0800

deepin-service-plugins (1.0.1) unstable; urgency=medium

  * chore: fix license check

 -- fuleyi <fuleyi@uniontech.com>  Thu, 24 Oct 2024 13:20:15 +0800

deepin-service-plugins (1.0.0) unstable; urgency=medium

  * Initial release. 

 -- fuleyi <fuleyi@uniontech.com>  Mon, 14 Oct 2024 13:48:23 +0800

=== debian/control ===
Source: deepin-service-plugins
Section: admin
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends:  debhelper (>= 11),
 pkg-config,
 cmake,
 qtbase5-dev,
 qttools5-dev-tools,
 qttools5-dev,
 libsystemd-dev,
 libpcap-dev,
 libnet-dev,
 libglib2.0-dev
Standards-Version: 4.1.3
Homepage: https://github.com/linuxdeepin

Package: deepin-service-plugins
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 deepin-service-manager (>= 1.0.5),
 qttools5-dev-tools
Description: deepin desktop-environment plugins service

Package: libdeepin-service-plugins-dev
Architecture: any
Depends:
 ${misc:Depends},
 libdeepin-service-plugins( =${binary:Version})
Description: deepin desktop-environment - service frame for development

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export QT_SELECT = qt5

PACK_VER = $(shell echo $(DEB_VERSION_UPSTREAM) | awk -F'[+_~-]' '{print $$1}')

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DVERSION=$(PACK_VER) -DCMAKE_CXX_FLAGS="-Wl,--as-needed" -DENABLE_PLUGIN_OOM=ON
